Index: /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/BDY/bdyini.F90
===================================================================
--- /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/BDY/bdyini.F90	(revision 15421)
+++ /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/BDY/bdyini.F90	(revision 15422)
@@ -167,6 +167,6 @@
       ! Check and write out namelist parameters
       ! -----------------------------------------
-      IF( jperio /= 0 )   CALL ctl_stop( 'bdy_segs: Cyclic or symmetric,',   &
-         &                               ' and general open boundary condition are not compatible' )
+!      IF( jperio /= 0 )   CALL ctl_stop( 'bdy_segs: Cyclic or symmetric,',   &
+!         &                               ' and general open boundary condition are not compatible' )
 
       IF(lwp) WRITE(numout,*) 'Number of open boundary sets : ', nb_bdy
Index: /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/DIA/diaharm.F90
===================================================================
--- /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/DIA/diaharm.F90	(revision 15421)
+++ /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/DIA/diaharm.F90	(revision 15422)
@@ -5,4 +5,8 @@
    !!======================================================================
    !! History :  3.1  !  2007  (O. Le Galloudec, J. Chanut)  Original code
+   !!  
+   !!   NB: 2017-12 : add 3D harmonic analysis of velocities  
+   !!                 integration of Maria Luneva's development  
+   !!   'key_3Ddiaharm
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers variables
@@ -13,4 +17,8 @@
    USE sbctide         ! Tidal forcing or not
    !
+# if defined key_3Ddiaharm  
+   USE zdf_oce  
+#endif  
+   !
    USE in_out_manager  ! I/O units
    USE iom             ! I/0 library
@@ -33,8 +41,13 @@
    INTEGER         ::   nb_ana        ! Number of harmonics to analyse
 
-   INTEGER , ALLOCATABLE, DIMENSION(:)       ::   name
-   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::   ana_temp
-   REAL(wp), ALLOCATABLE, DIMENSION(:)       ::   ana_freq, ut, vt, ft
-   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::   out_eta, out_u, out_v
+   INTEGER , ALLOCATABLE, DIMENSION(:)           ::   name 
+   REAL(wp), ALLOCATABLE, DIMENSION(:)           ::   ana_freq, ut, vt, ft  
+# if defined key_3Ddiaharm  
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:,:)   ::   ana_temp  
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:)     ::   out_eta, out_u, out_v, out_w, out_dzi  
+# else  
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:)     ::   ana_temp  
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)       ::   out_eta, out_u, out_v  
+# endif
 
    INTEGER  ::   ninco, nsparse
@@ -76,4 +89,7 @@
          WRITE(numout,*)
          WRITE(numout,*) 'dia_harm_init: Tidal harmonic analysis initialization'
+# if defined key_3Ddiaharm  
+         WRITE(numout,*) '  - 3D harmonic analysis of currents activated (key_3Ddiaharm)'  
+#endif
          WRITE(numout,*) '~~~~~~~~~~~~~ '
       ENDIF
@@ -155,6 +171,11 @@
          ! Initialize temporary arrays:
          ! ----------------------------
-         ALLOCATE( ana_temp(jpi,jpj,2*nb_ana,3) )
-         ana_temp(:,:,:,:) = 0._wp
+# if defined key_3Ddiaharm  
+         ALLOCATE( ana_temp( jpi, jpj, 2*nb_ana, 5, jpk ) )  
+         ana_temp(:,:,:,:,:) = 0._wp  
+# else  
+         ALLOCATE( ana_temp( jpi, jpj, 2*nb_ana, 3      ) )  
+         ana_temp(:,:,:,:  ) = 0._wp  
+#endif
 
       ENDIF
@@ -175,4 +196,7 @@
       !
       INTEGER  ::   ji, jj, jh, jc, nhc
+# if defined key_3Ddiaharm  
+      INTEGER  :: jk  
+# endif
       REAL(wp) ::   ztime, ztemp
       !!--------------------------------------------------------------------
@@ -190,11 +214,43 @@
                   &    +(1.-MOD(jc,2))* ft(jh) *SIN(ana_freq(jh)*ztime + vt(jh) + ut(jh)))
                   !
+               ! ssh, ub, vb are stored at the last level of 5d array
                DO jj = 2, jpjm1
                   DO ji = 2, jpim1
-                     ana_temp(ji,jj,nhc,1) = ana_temp(ji,jj,nhc,1) + ztemp * sshn(ji,jj) * ssmask (ji,jj) ! elevation      
-                     ana_temp(ji,jj,nhc,2) = ana_temp(ji,jj,nhc,2) + ztemp * un_b(ji,jj) * ssumask(ji,jj) ! u-vel
-                     ana_temp(ji,jj,nhc,3) = ana_temp(ji,jj,nhc,3) + ztemp * vn_b(ji,jj) * ssvmask(ji,jj) ! v-vel
+                     ! Elevation and currents  
+# if defined key_3Ddiaharm  
+                     ana_temp(ji,jj,nhc,1,jpk) = ana_temp(ji,jj,nhc,1,jpk) + ztemp*sshn(ji,jj)*ssmask (ji,jj)          
+                     ana_temp(ji,jj,nhc,2,jpk) = ana_temp(ji,jj,nhc,2,jpk) + ztemp*un_b(ji,jj)*ssumask(ji,jj)  
+                     ana_temp(ji,jj,nhc,3,jpk) = ana_temp(ji,jj,nhc,3,jpk) + ztemp*vn_b(ji,jj)*ssvmask(ji,jj)  
+  
+                     ana_temp(ji,jj,nhc,5,jpk) = ana_temp(ji,jj,nhc,5,jpk)                               &  
+                   &                              + ztemp*bfrva(ji,jj)*vn(ji,jj,mbkv(ji,jj))*ssvmask(ji,jj)  
+                     ana_temp(ji,jj,nhc,4,jpk) = ana_temp(ji,jj,nhc,4,jpk)                               &   
+                   &                              + ztemp*bfrua(ji,jj)*un(ji,jj,mbku(ji,jj))*ssumask(ji,jj)  
+# else  
+                      ana_temp(ji,jj,nhc,1) = ana_temp(ji,jj,nhc,1) + ztemp*sshn(ji,jj)*ssmask (ji,jj)          
+                      ana_temp(ji,jj,nhc,2) = ana_temp(ji,jj,nhc,2) + ztemp*un_b(ji,jj)*ssumask(ji,jj)  
+                      ana_temp(ji,jj,nhc,3) = ana_temp(ji,jj,nhc,3) + ztemp*vn_b(ji,jj)*ssvmask(ji,jj)  
+# endif
                   END DO
                END DO
+               ! 
+# if defined key_3Ddiaharm  
+! 3d velocity and density:  
+             DO jk=1,jpk-1  
+               DO jj = 1,jpj  
+                  DO ji = 1,jpi  
+                     ! density and velocity  
+                     ana_temp(ji,jj,nhc,1,jk) = ana_temp(ji,jj,nhc,1,jk) + ztemp*rhd(ji,jj,jk)  
+                     ana_temp(ji,jj,nhc,2,jk) = ana_temp(ji,jj,nhc,2,jk) + ztemp*(un(ji,jj,jk)-un_b(ji,jj)) &  
+                &                                          *umask(ji,jj,jk)  
+                     ana_temp(ji,jj,nhc,3,jk) = ana_temp(ji,jj,nhc,3,jk) + ztemp*(vn(ji,jj,jk)-vn_b(ji,jj)) &  
+                &                                          *vmask(ji,jj,jk)   
+                     ana_temp(ji,jj,nhc,4,jk) = ana_temp(ji,jj,nhc,4,jk) + ztemp*wn(ji,jj,jk)  
+   
+                     ana_temp(ji,jj,nhc,5,jk) = ana_temp(ji,jj,nhc,5,jk) - 0.5*grav*ztemp*(rhd(ji,jj,jk)+rhd(ji,jj,jk+1))/max(rn2(ji,jj,jk),1.e-8_wp)  
+                  END DO  
+               END DO  
+             ENDDO  
+# endif
             END DO
          END DO
@@ -218,4 +274,7 @@
       !!--------------------------------------------------------------------
       INTEGER  ::   ji, jj, jh, jc, jn, nhan
+# if defined key_3Ddiaharm  
+      INTEGER :: jk  
+# endif 
       INTEGER  ::   ksp, kun, keq
       REAL(wp) ::   ztime, ztime_ini, ztime_end, z1_han
@@ -226,6 +285,4 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
       
-      ALLOCATE( out_eta(jpi,jpj,2*nb_ana), out_u(jpi,jpj,2*nb_ana), out_v(jpi,jpj,2*nb_ana) )
-
       ztime_ini = nit000_han*rdt                 ! Initial time in seconds at the beginning of analysis
       ztime_end = nitend_han*rdt                 ! Final time in seconds at the end of analysis
@@ -233,4 +290,20 @@
       z1_han = 1._wp / REAL(nhan-1) 
       
+# if defined key_3Ddiaharm  
+      ALLOCATE( out_eta(jpi,jpj,jpk,2*nb_ana),   &  
+         &      out_u  (jpi,jpj,jpk,2*nb_ana),   &  
+         &      out_v  (jpi,jpj,jpk,2*nb_ana),   &  
+         &      out_w  (jpi,jpj,jpk,2*nb_ana),   &  
+         &      out_dzi(jpi,jpj,jpk,2*nb_ana) )  
+# else  
+      ALLOCATE( out_eta(jpi,jpj,2*nb_ana),   &  
+         &      out_u  (jpi,jpj,2*nb_ana),   &  
+         &      out_v  (jpi,jpj,2*nb_ana)  )  
+# endif  
+  
+      IF(lwp) WRITE(numout,*) 'ANA F OLD', ft   
+      IF(lwp) WRITE(numout,*) 'ANA U OLD', ut  
+      IF(lwp) WRITE(numout,*) 'ANA V OLD', vt
+
       ninco = 2*nb_ana
 
@@ -260,16 +333,28 @@
       CALL SUR_DETERMINE_INIT
 
-      ! Elevation:
+      ! Density and Elevation:  
+# if defined key_3Ddiaharm  
+    DO jk=1,jpk  
+# endif
       DO jj = 2, jpjm1
          DO ji = 2, jpim1
 
             ! Fill input array
+# if defined key_3Ddiaharm  
+            ztmp4(1:nb_ana*2) = ana_temp(ji,jj,1:nb_ana*2,1,jk)  
+# else
             ztmp4(1:nb_ana*2) = ana_temp(ji,jj,1:nb_ana*2,1)
+# endif
             CALL SUR_DETERMINE
             
             ! Fill output array
             DO jh = 1, nb_ana
-               out_eta(ji,jj,jh       ) =  ztmp7((jh-1)*2+1) * ssmask(ji,jj)
-               out_eta(ji,jj,jh+nb_ana) = -ztmp7((jh-1)*2+2) * ssmask(ji,jj)
+# if defined key_3Ddiaharm  
+               out_eta(ji,jj,jk,jh       ) =  ztmp7((jh-1)*2+1) * ssmask(ji,jj)
+               out_eta(ji,jj,jk,jh+nb_ana) = -ztmp7((jh-1)*2+2) * ssmask(ji,jj)
+# else  
+               out_eta(ji,jj,   jh       ) =  ztmp7((jh-1)*2+1) * ssmask(ji,jj)
+               out_eta(ji,jj,   jh+nb_ana) = -ztmp7((jh-1)*2+2) * ssmask(ji,jj)
+# endif
             END DO
          END DO
@@ -281,11 +366,21 @@
 
             ! Fill input array
+# if defined key_3Ddiaharm  
+            ztmp4(1:nb_ana*2) = ana_temp(ji,jj,1:nb_ana*2,2,jk)
+# else 
             ztmp4(1:nb_ana*2) = ana_temp(ji,jj,1:nb_ana*2,2)
+# endif
             CALL SUR_DETERMINE
 
             ! Fill output array
             DO jh = 1, nb_ana
-               out_u(ji,jj,       jh) =  ztmp7((jh-1)*2+1) * ssumask(ji,jj)
-               out_u(ji,jj,nb_ana+jh) = -ztmp7((jh-1)*2+2) * ssumask(ji,jj)
+# if defined key_3Ddiaharm  
+               out_u(ji,jj,jk,       jh) =  ztmp7((jh-1)*2+1) * ssumask(ji,jj)
+               out_u(ji,jj,jk,nb_ana+jh) = -ztmp7((jh-1)*2+2) * ssumask(ji,jj)
+# else  
+               out_u(ji,jj,          jh) =  ztmp7((jh-1)*2+1) * ssumask(ji,jj)
+               out_u(ji,jj,   nb_ana+jh) = -ztmp7((jh-1)*2+2) * ssumask(ji,jj)
+# endif
+
             END DO
 
@@ -298,15 +393,96 @@
 
             ! Fill input array
+# if defined key_3Ddiaharm  
+            ztmp4(1:nb_ana*2) = ana_temp(ji,jj,1:nb_ana*2,3,jk)
+# else
             ztmp4(1:nb_ana*2) = ana_temp(ji,jj,1:nb_ana*2,3)
+# endif
             CALL SUR_DETERMINE
 
             ! Fill output array
             DO jh = 1, nb_ana
-               out_v(ji,jj,       jh) =  ztmp7((jh-1)*2+1) * ssvmask(ji,jj)
-               out_v(ji,jj,nb_ana+jh) = -ztmp7((jh-1)*2+2) * ssvmask(ji,jj)
+# if defined key_3Ddiaharm  
+               out_v(ji,jj,jk,       jh) =  ztmp7((jh-1)*2+1) * ssvmask(ji,jj)
+               out_v(ji,jj,jk,nb_ana+jh) = -ztmp7((jh-1)*2+2) * ssvmask(ji,jj)
+# else  
+               out_v(ji,jj,          jh) =  ztmp7((jh-1)*2+1) * ssvmask(ji,jj)
+               out_v(ji,jj,   nb_ana+jh) = -ztmp7((jh-1)*2+2) * ssvmask(ji,jj)
+# endif
             END DO
 
          END DO
       END DO
+
+# if defined key_3Ddiaharm  
+      ! w- velocity  
+      DO jj = 1, jpj  
+         DO ji = 1, jpi  
+            ! Fill input array  
+            kun=0  
+            DO jh = 1,nb_ana  
+               DO jc = 1,2  
+                  kun = kun + 1  
+                  ztmp4(kun)=ana_temp(ji,jj,kun,4,jk)  
+               END DO  
+            END DO  
+  
+            CALL SUR_DETERMINE(jj+1)  
+  
+            ! Fill output array  
+            DO jh = 1, nb_ana  
+               ana_amp(ji,jj,jh,1)=ztmp7((jh-1)*2+1)  
+               ana_amp(ji,jj,jh,2)=ztmp7((jh-1)*2+2)  
+            END DO  
+  
+         END DO  
+      END DO  
+  
+      DO jj = 1, jpj  
+         DO ji = 1, jpi  
+            DO jh = 1, nb_ana  
+               X1=ana_amp(ji,jj,jh,1)  
+               X2=-ana_amp(ji,jj,jh,2)  
+               out_w(ji,jj,jk,       jh)=X1 * tmask_i(ji,jj)  
+               out_w(ji,jj,jk,nb_ana+jh)=X2 * tmask_i(ji,jj)  
+            END DO  
+         END DO  
+      END DO  
+  
+       ! dzi- isopycnal displacements  
+      DO jj = 1, jpj  
+         DO ji = 1, jpi  
+            ! Fill input array  
+            kun=0  
+            DO jh = 1,nb_ana  
+               DO jc = 1,2  
+                  kun = kun + 1  
+                  ztmp4(kun)=ana_temp(ji,jj,kun,5,jk)  
+               END DO  
+            END DO  
+  
+            CALL SUR_DETERMINE(jj+1)  
+  
+            ! Fill output array  
+            DO jh = 1, nb_ana  
+               ana_amp(ji,jj,jh,1)=ztmp7((jh-1)*2+1)  
+               ana_amp(ji,jj,jh,2)=ztmp7((jh-1)*2+2)  
+            END DO  
+  
+         END DO  
+      END DO  
+  
+      DO jj = 1, jpj  
+         DO ji = 1, jpi  
+            DO jh = 1, nb_ana  
+               X1=ana_amp(ji,jj,jh,1)  
+               X2=-ana_amp(ji,jj,jh,2)  
+               out_dzi(ji,jj,jk,       jh)=X1 * tmask_i(ji,jj)  
+               out_dzi(ji,jj,jk,nb_ana+jh)=X2 * tmask_i(ji,jj)  
+            END DO  
+         END DO  
+      END DO  
+  
+   ENDDO ! jk  
+# endif
       !
       ! clem: we could avoid this call if all the loops were from 1:jpi and 1:jpj
@@ -328,31 +504,163 @@
       !!--------------------------------------------------------------------
       INTEGER  ::   jh
-      !!----------------------------------------------------------------------
+ 
+# if defined key_3Ddiaharm  
+      CHARACTER(LEN=lc) :: cdfile_name_W         ! name of the file created (W-points)  
+      INTEGER  :: jk  
+      REAL(WP), ALLOCATABLE, DIMENSION (:,:,:) :: z3real, z3im   
+      REAL(WP), ALLOCATABLE, DIMENSION (:,:)   :: z2real, z2im        
+# endif  
+!!----------------------------------------------------------------------  
+  
+#if defined key_dimgout  
+      cdfile_name_T = TRIM(cexper)//'_Tidal_harmonics_gridT.dimgproc'  
+      cdfile_name_U = TRIM(cexper)//'_Tidal_harmonics_gridU.dimgproc'  
+      cdfile_name_V = TRIM(cexper)//'_Tidal_harmonics_gridV.dimgproc'  
+#   if defined key_3Ddiaharm  
+      cdfile_name_W = TRIM(cexper)//'_Tidal_harmonics_gridW.dimgproc'  
+#   endif  
+#endif
 
       IF(lwp) WRITE(numout,*) '  '
       IF(lwp) WRITE(numout,*) 'dia_wri_harm : Write harmonic analysis results'
+#if defined key_dimgout  
+      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~  Output files: ', TRIM(cdfile_name_T)  
+      IF(lwp) WRITE(numout,*) '                             ', TRIM(cdfile_name_U)  
+      IF(lwp) WRITE(numout,*) '                             ', TRIM(cdfile_name_V)  
+#   if defined key_3Ddiaharm  
+      IF(lwp) WRITE(numout,*) '                             ', TRIM(cdfile_name_W)  
+#   endif  
+#endif
       IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
 
-      ! A) Elevation
+# if defined key_3Ddiaharm  
+      ALLOCATE(z3real(jpi,jpj,jpk),z3im(jpi,jpj,jpk),z2real(jpi,jpj),z2im(jpi,jpj))  
+# endif  
+  
+      ! A) density and elevation
       !/////////////
+#if defined key_dimgout  
+      cltext='density amplitude and phase; elevation is level=jpk '  
+      CALL dia_wri_dimg(TRIM(cdfile_name_T), TRIM(cltext), out_eta, 2*nb_ana, '2')  
+#else  
+#   if defined key_3Ddiaharm  
+      z3real(:,:,:) = 0._wp; z3im(:,:,:) = 0._wp  
+#   endif
       DO jh = 1, nb_ana
+#   if defined key_3Ddiaharm  
+        DO jk=1,jpkm1  
+          z3real(:,:,jk)=out_eta(:,:,jk,jh)  
+          z3im  (:,:,jk)=out_eta(:,:,jk,jh+nb_ana)  
+        ENDDO  
+      z2real(:,:)=out_eta(:,:,jpk,jh); z2im(:,:)=out_eta(:,:,jpk,jh+nb_ana)  
+      CALL iom_put( TRIM(tname(jh))//'x_ro', z3real(:,:,:) )  
+      CALL iom_put( TRIM(tname(jh))//'y_ro', z3im  (:,:,:) )  
+      CALL iom_put( TRIM(tname(jh))//'x'   , z2real(:,:  ) )  
+      CALL iom_put( TRIM(tname(jh))//'y'   , z2im  (:,:  ) )  
+#   else   
+      WRITE(numout,*) "OUTPUT ORI: ", TRIM(tname(jh))//'x', ' & ', TRIM(tname(jh))//'y', MAXVAL(out_eta(:,:,jh))
       CALL iom_put( TRIM(tname(jh))//'x', out_eta(:,:,jh) )
       CALL iom_put( TRIM(tname(jh))//'y', out_eta(:,:,jh+nb_ana) )
-      END DO
-
-      ! B) ubar
+#   endif  
+      END DO  
+#endif  
+  
+      ! B) u
       !/////////
+#if defined key_dimgout  
+      cltext='3d u amplitude and phase; ubar is the last level'  
+      CALL dia_wri_dimg(TRIM(cdfile_name_U), TRIM(cltext), out_u, 2*nb_ana, '2')  
+#else  
+#   if defined key_3Ddiaharm  
+      z3real(:,:,:) = 0._wp; z3im(:,:,:) = 0._wp  
+#   endif
       DO jh = 1, nb_ana
-      CALL iom_put( TRIM(tname(jh))//'x_u', out_u(:,:,jh) )
-      CALL iom_put( TRIM(tname(jh))//'y_u', out_u(:,:,jh+nb_ana) )
-      END DO
-
-      ! C) vbar
+#   if defined key_3Ddiaharm  
+        DO jk=1,jpkm1  
+          z3real(:,:,jk)=out_u(:,:,jk,jh)  
+          z3im  (:,:,jk)=out_u(:,:,jk,jh+nb_ana)  
+        ENDDO  
+        z2real(:,:)=out_u(:,:,jpk,jh); z2im(:,:)=out_u(:,:,jpk,jh+nb_ana)  
+        CALL iom_put( TRIM(tname(jh))//'x_u3d', z3real(:,:,:) )  
+        CALL iom_put( TRIM(tname(jh))//'y_u3d', z3im (:,:,:)  )  
+        CALL iom_put( TRIM(tname(jh))//'x_u2d', z2real(:,:) )  
+        CALL iom_put( TRIM(tname(jh))//'y_u2d', z2im (:,:)  )  
+        z2real(:,:)=out_w(:,:,jpk,jh); z2im(:,:)=out_w(:,:,jpk,jh+nb_ana)  
+        CALL iom_put( TRIM(tname(jh))//'x_tabx', z2real(:,:) )  
+        CALL iom_put( TRIM(tname(jh))//'y_tabx', z2im (:,:)  )  
+#   else  
+        CALL iom_put( TRIM(tname(jh))//'x_u2d', out_u(:,:,jh) )  
+        CALL iom_put( TRIM(tname(jh))//'y_u2d', out_u(:,:,nb_ana+jh) )  
+#   endif  
+      END DO  
+#endif  
+  
+      ! C) v
       !/////////
+#if defined key_dimgout  
+      cltext='3d v amplitude and phase; vbar is the last level'  
+      CALL dia_wri_dimg(TRIM(cdfile_name_V), TRIM(cltext), out_v, 2*nb_ana, '2')  
+#else  
+#   if defined key_3Ddiaharm  
+      z3real(:,:,:) = 0._wp; z3im(:,:,:) = 0._wp  
+#   endif
       DO jh = 1, nb_ana
-         CALL iom_put( TRIM(tname(jh))//'x_v', out_v(:,:,jh       ) )
-         CALL iom_put( TRIM(tname(jh))//'y_v', out_v(:,:,jh+nb_ana) )
-      END DO
-      !
+#   if defined key_3Ddiaharm  
+        DO jk=1,jpkm1  
+          z3real(:,:,jk)=out_v(:,:,jk,jh)  
+          z3im  (:,:,jk)=out_v(:,:,jk,jh+nb_ana)  
+        ENDDO  
+        z2real(:,:)=out_v(:,:,jpk,jh); z2im(:,:)=out_v(:,:,jpk,jh+nb_ana)  
+        CALL iom_put( TRIM(tname(jh))//'x_v3d', z3real(:,:,:) )  
+        CALL iom_put( TRIM(tname(jh))//'y_v3d', z3im (:,:,:)  )  
+        CALL iom_put( TRIM(tname(jh))//'x_v2d'  , z2real(:,:) )  
+        CALL iom_put( TRIM(tname(jh))//'y_v2d'  , z2im (:,:)  )  
+        z2real(:,:)=out_dzi(:,:,jpk,jh); z2im(:,:)=out_dzi(:,:,jpk,jh+nb_ana)  
+        CALL iom_put( TRIM(tname(jh))//'x_taby', z2real(:,:) )  
+        CALL iom_put( TRIM(tname(jh))//'y_taby', z2im (:,:)  )  
+#   else  
+         CALL iom_put( TRIM(tname(jh))//'x_v2d', out_v(:,:,jh ) )  
+         CALL iom_put( TRIM(tname(jh))//'y_v2d', out_v(:,:,jh+nb_ana) )  
+#   endif  
+       END DO  
+  
+#endif  
+      ! D) w  
+# if defined key_3Ddiaharm  
+#   if defined key_dimgout  
+      cltext='3d w amplitude and phase; vort_baro is the last level'  
+      CALL dia_wri_dimg(TRIM(cdfile_name_W), TRIM(cltext), out_w, 2*nb_ana, '2')  
+#   else  
+      DO jh = 1, nb_ana  
+        DO jk=1,jpkm1  
+         z3real(:,:,jk)=out_w(:,:,jk,jh)  
+         z3im(:,:,jk)=out_w(:,:,jk,jh+nb_ana)  
+        ENDDO  
+        CALL iom_put( TRIM(tname(jh))//'x_w3d', z3real(:,:,:) )  
+        CALL iom_put( TRIM(tname(jh))//'y_w3d', z3im(:,:,:) )  
+      END DO  
+#   endif  
+  
+!       E) dzi + tau_bot  
+#   if defined key_dimgout  
+      cltext='dzi=g*ro/N2 amplitude and phase'  
+      CALL dia_wri_dimg(TRIM(cdfile_name_W), TRIM(cltext), out_w, 2*nb_ana, '2')  
+#   else  
+      DO jh = 1, nb_ana  
+        DO jk=1,jpkm1  
+         z3real(:,:,jk)=out_dzi(:,:,jk,jh)  
+         z3im(:,:,jk)=out_dzi(:,:,jk,jh+nb_ana)  
+        ENDDO  
+        CALL iom_put( TRIM(tname(jh))//'x_dzi', z3real(:,:,:) )  
+        CALL iom_put( TRIM(tname(jh))//'y_dzi', z3im(:,:,:) )  
+      END DO  
+#   endif  
+# endif   
+  
+      !  
+# if defined key_3Ddiaharm  
+   DEALLOCATE(z3real, z3im, z2real,z2im)  
+# endif
+
    END SUBROUTINE dia_wri_harm
 
